#define OPTIMIZED_ARGUMENTS
#include <mmcompiler/mmx_compiler.hpp>

void mmx_initialize_A ();
typedef generic Ring_EL_1;

struct Ring_1_rep: public rep_struct {
  virtual Ring_EL_1
  MM_5 (const Ring_EL_1 &MM_ARG1_5) const {
    throw string ("not implemented");
  }
  
  virtual Ring_EL_1
  PP_4 (const Ring_EL_1 &PP_ARG1_4, const Ring_EL_1 &PP_ARG2_4) const {
    throw string ("not implemented");
  }
  
  virtual Ring_EL_1
  MM_6 (const Ring_EL_1 &MM_ARG1_6, const Ring_EL_1 &MM_ARG2_6) const {
    throw string ("not implemented");
  }
  
  virtual Ring_EL_1
  TT_5 (const Ring_EL_1 &TT_ARG1_5, const Ring_EL_1 &TT_ARG2_5) const {
    throw string ("not implemented");
  }
  
  inline Ring_1_rep () {}
  virtual inline ~Ring_1_rep () {}
};

struct Ring_1 {
  Ring_1_rep *rep;
  inline Ring_1 (): rep (new Ring_1_rep ()) {}
  
  inline ~Ring_1 () {
    DEC_COUNT (rep);
  }
  
  inline Ring_1 (const Ring_1 &x): rep (x.rep) {
    INC_COUNT (rep);
  }
  
  inline Ring_1
  &operator = (const Ring_1 &x) {
    INC_COUNT (x.rep);
    DEC_COUNT (rep);
    rep = x.rep;
    return *this;
  }
  
  inline Ring_1 (const Ring_1_rep *x): rep (const_cast<Ring_1_rep* > (x)) {
    INC_COUNT (rep);
  }
  
  inline const Ring_1_rep
  *operator -> () const {
    return rep;
  }
};

inline Ring_1
copy (const Ring_1 &x) {
  return Ring_1 ();
}

inline Ring_1_rep
*access (Ring_1 &x) {
  if (x.rep->ref_count > 1) x = copy (x);
  return x.rep;
}

static function_2<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& > LAMBDA_NEW_pE1 (const Ring_1 &R_1);

struct Int_Ring_pE1_rep: public Ring_1_rep {
  Ring_EL_1
  MM_5 (const Ring_EL_1 &ARG1_1) const {
    return concrete_to_abstract<int, Ring_EL_1 > (-abstract_to_concrete<Ring_EL_1, int > (ARG1_1));
  }
  
  Ring_EL_1
  PP_4 (const Ring_EL_1 &ARG1_2, const Ring_EL_1 &ARG2_1) const {
    return concrete_to_abstract<int, Ring_EL_1 > (abstract_to_concrete<Ring_EL_1, int > (ARG1_2) + abstract_to_concrete<Ring_EL_1, int > (ARG2_1));
  }
  
  Ring_EL_1
  MM_6 (const Ring_EL_1 &ARG1_2, const Ring_EL_1 &ARG2_1) const {
    return concrete_to_abstract<int, Ring_EL_1 > (abstract_to_concrete<Ring_EL_1, int > (ARG1_2) - abstract_to_concrete<Ring_EL_1, int > (ARG2_1));
  }
  
  Ring_EL_1
  TT_5 (const Ring_EL_1 &ARG1_2, const Ring_EL_1 &ARG2_1) const {
    return concrete_to_abstract<int, Ring_EL_1 > (abstract_to_concrete<Ring_EL_1, int > (ARG1_2) * abstract_to_concrete<Ring_EL_1, int > (ARG2_1));
  }
  
  inline Int_Ring_pE1_rep () {}
};

static Ring_1
Int_Ring_pE1 () {
  return Ring_1 (new Int_Ring_pE1_rep ());
}

static function_2<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& >
LAMBDA_pE2 (const Ring_1 &R_1) {
  return LAMBDA_NEW_pE1 (R_1);
}

struct LAMBDA_NEW_pE1_rep: public function_2_rep<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& > {
  Ring_1 R_1;
  
  Ring_EL_1
  apply (const Ring_EL_1 &x_1, const Ring_EL_1 &y_1) {
    return (R_1->PP_4 ((R_1->TT_5 (x_1, x_1)), (R_1->TT_5 (y_1, y_1))));
  }
  
  inline LAMBDA_NEW_pE1_rep (const Ring_1 &R_1_bis): R_1 (R_1_bis) {}
};

static function_2<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& >
LAMBDA_NEW_pE1 (const Ring_1 &R_1) {
  return function_2<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& > (new LAMBDA_NEW_pE1_rep (R_1));
}

function_1<function_2<Ring_EL_1, const Ring_EL_1& , const Ring_EL_1& > , const Ring_1& > fun_E1;

void
mmx_initialize_E () {
  static bool done = false;
  if (done) return;
  done = true;
  mmx_initialize_A ();
  fun_E1 = LAMBDA_pE2;
  {
    const iterator<int> AUX_it_1 = iterator_natural_range<int > (1, 10);
    for (; iterator_busy<int > (AUX_it_1); iterator_increase<int > (AUX_it_1)) {
      const int i_1 = iterator_current<int > (AUX_it_1);
      output_to_port<string > (output_to_port<Ring_EL_1 > (output_to_port<string > (output_to_port<int > (mmout, i_1), string (" -> ")), (fun_E1 (Int_Ring_pE1 ()) (as<Ring_EL_1 > (i_1), as<Ring_EL_1 > (10)))), string ("\n"));
    }
  }
}
